org.w3c.css.sac

## Class InputSource

- java.lang.Object
- - org.w3c.css.sac.InputSource

    public class InputSource
    extends java.lang.Object

A single input source for a CSS source.

This class allows a CSS application to encapsulate information about an input source in a single object, which may include a URI, a byte stream (possibly with a specified encoding), and/or a character stream.

The CSS parser will use the InputSource object to determine how to read CSS input. If there is a character stream available, the parser will read that stream directly; if not, the parser will use a byte stream, if available; if neither a character stream nor a byte stream is available, the parser will attempt to open a URI connection to the resource identified by the URI.

An InputSource object belongs to the application: the CSS parser shall never modify it in any way (it may modify a copy if necessary).

### Constructor Summary

Constructors
Constructor and Description
`InputSource()` Zero-argument default constructor.
`InputSource(java.io.Reader characterStream)` Create a new input source with a character stream.
`InputSource(java.lang.String uri)` Create a new input source with a URI.

### Method Summary

All Methods Instance Methods Concrete Methods
`java.io.InputStream` `getByteStream()` Get the byte stream for this input source.
`java.io.Reader` `getCharacterStream()` Get the character stream for this input source.
`java.lang.String` `getEncoding()` Get the character encoding for a byte stream or URI.
`java.lang.String` `getMedia()` Returns the media associated to the input source or `null` if media are currently unknown.
`java.lang.String` `getTitle()` Returns the title for this input source.
`java.lang.String` `getURI()` Get the URI for this input source.
`void` `setByteStream(java.io.InputStream byteStream)` Set the byte stream for this input source.
`void` `setCharacterStream(java.io.Reader characterStream)` Set the character stream for this input source.
`void` `setEncoding(java.lang.String encoding)` Set the character encoding, if known.
`void` `setMedia(java.lang.String media)` Set the media for this input source.
`void` `setTitle(java.lang.String title)` Set the title for this input source.
`void` `setURI(java.lang.String uri)` Set the URI for this input source.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### InputSource

    public InputSource()

Zero-argument default constructor.

See Also:
  `setURI(java.lang.String)`, `setByteStream(java.io.InputStream)`, `setCharacterStream(java.io.Reader)`, `setEncoding(java.lang.String)`

#### InputSource

    public InputSource(java.lang.String uri)

Create a new input source with a URI.

The URI must be full resolved.

Parameters:
  `uri` - The URI.
See Also:
  `setURI(java.lang.String)`, `setByteStream(java.io.InputStream)`, `setEncoding(java.lang.String)`, `setCharacterStream(java.io.Reader)`

#### InputSource

    public InputSource(java.io.Reader characterStream)

Create a new input source with a character stream.

Application writers may use setURI() to provide a base for resolving relative URIs, and setPublicId to include a public identifier.

The character stream shall not include a byte order mark.

See Also:
  `setURI(java.lang.String)`, `setByteStream(java.io.InputStream)`, `setCharacterStream(java.io.Reader)`

### Method Detail

#### setURI

    public void setURI(java.lang.String uri)

Set the URI for this input source.

The URI is optional if there is a byte stream or a character stream, but it is still useful to provide one, since the application can use it to resolve relative URIs and can include it in error messages and warnings (the parser will attempt to open a connection to the URI only if there is no byte stream or character stream specified).

If the application knows the character encoding of the object pointed to by the URI, it can register the encoding using the setEncoding method.

The URI must be fully resolved.

Parameters:
  `uri` - The URI as a string.
See Also:
  `setEncoding(java.lang.String)`, `getURI()`, `Locator.getURI()`, `CSSParseException.getURI()`

#### getURI

    public java.lang.String getURI()

Get the URI for this input source.

The getEncoding method will return the character encoding of the object pointed to, or null if unknown.

The URI will be fully resolved.

Returns:
  The URI.
See Also:
  `setURI(java.lang.String)`, `getEncoding()`

#### setByteStream

    public void setByteStream(java.io.InputStream byteStream)

Set the byte stream for this input source.

The SAX parser will ignore this if there is also a character stream specified, but it will use a byte stream in preference to opening a URI connection itself.

If the application knows the character encoding of the byte stream, it should set it with the setEncoding method.

Parameters:
  `byteStream` - A byte stream containing an CSS document or other entity.
See Also:
  `setEncoding(java.lang.String)`, `getByteStream()`, `getEncoding()`

#### getByteStream

    public java.io.InputStream getByteStream()

Get the byte stream for this input source.

The getEncoding method will return the character encoding for this byte stream, or null if unknown.

Returns:
  The byte stream, or null if none was supplied.
See Also:
  `getEncoding()`, `setByteStream(java.io.InputStream)`

#### setEncoding

    public void setEncoding(java.lang.String encoding)

Set the character encoding, if known.

The encoding must be a string acceptable for an CHARSET encoding declaration (see section 4.4 of the CSS recommendation Level 2).

This method has no effect when the application provides a character stream.

Parameters:
  `encoding` - A string describing the character encoding.
See Also:
  `setURI(java.lang.String)`, `setByteStream(java.io.InputStream)`, `getEncoding()`

#### getEncoding

    public java.lang.String getEncoding()

Get the character encoding for a byte stream or URI.

Returns:
  The encoding, or null if none was supplied.
See Also:
  `setByteStream(java.io.InputStream)`, `getURI()`, `getByteStream()`

#### setCharacterStream

    public void setCharacterStream(java.io.Reader characterStream)

Set the character stream for this input source.

If there is a character stream specified, the SAX parser will ignore any byte stream and will not attempt to open a URI connection to the URI.

Parameters:
  `characterStream` - The character stream containing the CSS document or other entity.
See Also:
  `getCharacterStream()`

#### getCharacterStream

    public java.io.Reader getCharacterStream()

Get the character stream for this input source.

Returns:
  The character stream, or null if none was supplied.
See Also:
  `setCharacterStream(java.io.Reader)`

#### setTitle

    public void setTitle(java.lang.String title)

Set the title for this input source.

Parameters:
  `title` - The advisory title. See the title attribute definition for the LINK element in HTML 4.0, and the title pseudo-attribute for the XML style sheet processing instruction.

#### getTitle

    public java.lang.String getTitle()

Returns the title for this input source.

#### setMedia

    public void setMedia(java.lang.String media)

Set the media for this input source.

Parameters:
  `media` - A comma separated list with all media.

#### getMedia

    public java.lang.String getMedia()

Returns the media associated to the input source or `null` if media are currently unknown.

Returns:
  the media associated to this input source.